// ***************************************************************************************
// File: thread.h
// Description: session threads
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

#ifndef _THREAD_H
#define _THREAD_H

#include "task.h"
#include "util.h"

// Classes declared in this file
class NvSessionThread;



class NvSessionThread : public NvTask
{
public:

	std::string m_sSessionId;				// Current thread session id
	std::string m_sCallingSessionId;		// Calling session id
	bool b_Initialized;
	std::string m_sProcName;				// Procedure to run
	std::string m_sProcNameFailed;			// Procedure to run in cas of failure



	NvSessionThread();


// Overridable callbacks
protected:
	virtual int Main();
	virtual void OnException(std::string sInfo);
	virtual bool OnInit();
	virtual void OnCleanup();

public:
	
	// Starts the thread (return the session ID)
	std::string Start(const char *CallingSessionId, const char *AppName, const char *ProcName = NULL, const char *ProcNameFailed = NULL, const char *UserName = NULL, const char *OpenProc = NULL, const char *CloseProc = NULL, const char *Language = NULL);
};





#endif //_THREAD_H
